[Dell E5420/E5420m/E5520/E5520M/E6520/M6600/M4600] SD card and Firewire devices are not detected when attached to o2micro controller

Bug #801719 reported by Marc Legris on 2011-06-24
94
This bug affects 23 people
Affects Status Importance Assigned to Milestone
linux (Ubuntu)
High
Ming Lei
Natty
High
Ming Lei
Oneiric
High
Ming Lei
Precise
Undecided
Unassigned

Bug Description

Looks like this system has an 02 Micro Inc device. Will try -update and -proposed and report back.

ProblemType: Bug
DistroRelease: Ubuntu 11.04
Package: linux-image-2.6.38-8-generic 2.6.38-8.42
ProcVersionSignature: Ubuntu 2.6.38-8.42-generic 2.6.38.2
Uname: Linux 2.6.38-8-generic i686
NonfreeKernelModules: nvidia
AlsaVersion: Advanced Linux Sound Architecture Driver Version 1.0.23.
Architecture: i386
ArecordDevices:
 **** List of CAPTURE Hardware Devices ****
 card 0: PCH [HDA Intel PCH], device 0: STAC92xx Analog [STAC92xx Analog]
   Subdevices: 0/1
   Subdevice #0: subdevice #0
AudioDevicesInUse:
 USER PID ACCESS COMMAND
 /dev/snd/controlC0: u 1360 F.... pulseaudio
 /dev/snd/pcmC0D0c: u 1360 F...m pulseaudio
CRDA: Error: [Errno 2] No such file or directory
Card0.Amixer.info:
 Card hw:0 'PCH'/'HDA Intel PCH at 0xe1e60000 irq 52'
   Mixer name : 'IDT 92HD90BXX'
   Components : 'HDA:111d76e7,102804a4,00100102'
   Controls : 15
   Simple ctrls : 10
Card1.Amixer.info:
 Card hw:1 'NVidia'/'HDA NVidia at 0xe0080000 irq 17'
   Mixer name : 'Nvidia GPU 12 HDMI/DP'
   Components : 'HDA:10de0012,10de0101,00100100'
   Controls : 16
   Simple ctrls : 4
Date: Fri Jun 24 15:28:15 2011
HibernationDevice: RESUME=UUID=ebf1abad-9865-48f1-817c-f51fe02fe139
InstallationMedia: Ubuntu 11.04 "Natty Narwhal" - Release i386 (20110427.1)
MachineType: Dell Inc. Precision M6600
ProcEnviron:
 LANGUAGE=en_US:en
 LANG=en_US.UTF-8
 SHELL=/bin/bash
ProcKernelCmdLine: BOOT_IMAGE=/boot/vmlinuz-2.6.38-8-generic root=UUID=8cea2fdb-90e1-44e6-bec8-b2d157d4272d ro quiet splash vt.handoff=7
RelatedPackageVersions:
 linux-restricted-modules-2.6.38-8-generic N/A
 linux-backports-modules-2.6.38-8-generic N/A
 linux-firmware 1.52
SourcePackage: linux
UpgradeStatus: No upgrade log present (probably fresh install)
dmi.bios.date: 03/04/2011
dmi.bios.vendor: Dell Inc.
dmi.bios.version: X27
dmi.board.vendor: Dell Inc.
dmi.chassis.type: 9
dmi.chassis.vendor: Dell Inc.
dmi.modalias: dmi:bvnDellInc.:bvrX27:bd03/04/2011:svnDellInc.:pnPrecisionM6600:pvr01:rvnDellInc.:rn:rvr:cvnDellInc.:ct9:cvr:
dmi.product.name: Precision M6600
dmi.product.version: 01
dmi.sys.vendor: Dell Inc.

Brad Figg (brad-figg) on 2011-06-24
Changed in linux (Ubuntu):
status: New → Confirmed
Chris Van Hoof (vanhoof) wrote :

Marc -- This does indeed look like the same device. Does the sd card reader work? If so, confirm that firewire is not disabled in the BIOS

Changed in linux (Ubuntu):
assignee: nobody → Chris Van Hoof (vanhoof)
importance: Undecided → High
status: Confirmed → Incomplete
Stefan Richter (stefan-r-ubz) wrote :

From lspci:
> 0b:00.0 FireWire (IEEE 1394) [0c00]: O2 Micro, Inc. Device [1217:11f7] (rev 05) (prog-if 10 [OHCI])

From dmesg:
> [ 2.625857] firewire_ohci 0000:0b:00.0: PCI INT A -> GSI 19 (level, low) -> IRQ 19
> [ 2.625866] firewire_ohci 0000:0b:00.0: setting latency timer to 64
> [ 2.680992] firewire_ohci 0000:0b:00.0: irq 42 for MSI/MSI-X
> [ 2.681038] firewire_ohci: Added fw-ohci device 0000:0b:00.0, OHCI v1.10, 8 IR + 8 IT contexts, quirks 0x0

I didn't know until know that O2 Micro have a native PCI Express FireWire controller. ... Perhaps MSI support is broken in this device. Try:

# modprobe -r firewire-ohci
# modprobe firewire-ohci quirks=0x10

Then confirm with "dmesg | tail -55" that the driver was unloaded and re-loaded with the 0x10 quirks flag which disables MSI. After that, attach whatever FireWire device you are having and watch dmesg again for new messages. If nothing seems to happen, check again after about half a minute.

If this does still not show anything in the log, repeat with

# modprobe -r firewire-ohci
# modprobe firewire-ohci quirks=0x10 debug=0xf

Chris -- Media card and firewire are enabled in the bios, and the SD card works

Stefan -- Running the two modprobe commands the system now sees the firewire device and automounts it.

Changed in linux (Ubuntu):
status: Incomplete → Confirmed
Chris Van Hoof (vanhoof) on 2011-07-15
Changed in linux (Ubuntu):
assignee: Chris Van Hoof (vanhoof) → Kamal Mostafa (kamalmostafa)
assignee: Kamal Mostafa (kamalmostafa) → Li Li (lli5)

On the M4600, comment #3 also solves sd cards not being auto-mounted.

summary: - [Precision M6600] Unable to connect to Firewire device
+ [Precision M6600/M4600] Unable to connect to Firewire device
Chris Van Hoof (vanhoof) on 2011-07-25
summary: - [Precision M6600/M4600] Unable to connect to Firewire device
+ [Dell E5520/E5520M/E6520/M6600/M4600] SD card and Firewire devices are
+ not detected when attached to o2micro controller
Chris Van Hoof (vanhoof) on 2011-07-25
summary: - [Dell E5520/E5520M/E6520/M6600/M4600] SD card and Firewire devices are
- not detected when attached to o2micro controller
+ [Dell E5420/E5520/E5520M/E6520/M6600/M4600] SD card and Firewire devices
+ are not detected when attached to o2micro controller
summary: - [Dell E5420/E5520/E5520M/E6520/M6600/M4600] SD card and Firewire devices
- are not detected when attached to o2micro controller
+ [Dell E5420/E5420m/E5520/E5520M/E6520/M6600/M4600] SD card and Firewire
+ devices are not detected when attached to o2micro controller
Chris Van Hoof (vanhoof) on 2011-08-02
Changed in linux (Ubuntu):
assignee: Li Li (lli5) → Ming Lei (tom-leiming)
Changed in linux (Ubuntu Natty):
importance: Undecided → High
status: New → Confirmed
assignee: nobody → Ming Lei (tom-leiming)

Hi guys,

Could you help to test the attachment patch for the problem?

thanks,
--
Ming Lei

Ming Lei (tom-leiming) wrote :

Attach the generated package which is built from 2.6.38-11 plus the patch fireware_ohci_disable_msi.patch(see #6).

Could anyone test it on the machine so that we can push it into upstream?

thanks,

Hi Ming, can you build the packages for i386 so I can test on the machines I have that are not amd64 architecture?

Ming Lei (tom-leiming) wrote :
Download full text (3.2 KiB)

Marc,

I have built packages for i386 on the link:

http://kernel.ubuntu.com/~ming/bugs/801719/linux-2.6.38-11.i386.tar.gz

On Sat, Aug 6, 2011 at 3:56 AM, Marc Legris <email address hidden> wrote:
> Hi Ming, can you build the packages for i386 so I can test on the
> machines I have that are not amd64 architecture?
>
> --
> You received this bug notification because you are a bug assignee.
> https://bugs.launchpad.net/bugs/801719
>
> Title:
>  [Dell E5420/E5420m/E5520/E5520M/E6520/M6600/M4600] SD card and
>  Firewire devices are not detected when attached to o2micro controller
>
> Status in “linux” package in Ubuntu:
>  Confirmed
> Status in “linux” source package in Natty:
>  Confirmed
>
> Bug description:
>  Looks like this system has an 02 Micro Inc device. Will try -update
>  and -proposed and report back.
>
>  ProblemType: Bug
>  DistroRelease: Ubuntu 11.04
>  Package: linux-image-2.6.38-8-generic 2.6.38-8.42
>  ProcVersionSignature: Ubuntu 2.6.38-8.42-generic 2.6.38.2
>  Uname: Linux 2.6.38-8-generic i686
>  NonfreeKernelModules: nvidia
>  AlsaVersion: Advanced Linux Sound Architecture Driver Version 1.0.23.
>  Architecture: i386
>  ArecordDevices:
>   **** List of CAPTURE Hardware Devices ****
>   card 0: PCH [HDA Intel PCH], device 0: STAC92xx Analog [STAC92xx Analog]
>     Subdevices: 0/1
>     Subdevice #0: subdevice #0
>  AudioDevicesInUse:
>   USER        PID ACCESS COMMAND
>   /dev/snd/controlC0:  u          1360 F.... pulseaudio
>   /dev/snd/pcmC0D0c:   u          1360 F...m pulseaudio
>  CRDA: Error: [Errno 2] No such file or directory
>  Card0.Amixer.info:
>   Card hw:0 'PCH'/'HDA Intel PCH at 0xe1e60000 irq 52'
>     Mixer name : 'IDT 92HD90BXX'
>     Components : 'HDA:111d76e7,102804a4,00100102'
>     Controls      : 15
>     Simple ctrls  : 10
>  Card1.Amixer.info:
>   Card hw:1 'NVidia'/'HDA NVidia at 0xe0080000 irq 17'
>     Mixer name : 'Nvidia GPU 12 HDMI/DP'
>     Components : 'HDA:10de0012,10de0101,00100100'
>     Controls      : 16
>     Simple ctrls  : 4
>  Date: Fri Jun 24 15:28:15 2011
>  HibernationDevice: RESUME=UUID=ebf1abad-9865-48f1-817c-f51fe02fe139
>  InstallationMedia: Ubuntu 11.04 "Natty Narwhal" - Release i386 (20110427.1)
>  MachineType: Dell Inc. Precision M6600
>  ProcEnviron:
>   LANGUAGE=en_US:en
>   LANG=en_US.UTF-8
>   SHELL=/bin/bash
>  ProcKernelCmdLine: BOOT_IMAGE=/boot/vmlinuz-2.6.38-8-generic root=UUID=8cea2fdb-90e1-44e6-bec8-b2d157d4272d ro quiet splash vt.handoff=7
>  RelatedPackageVersions:
>   linux-restricted-modules-2.6.38-8-generic N/A
>   linux-backports-modules-2.6.38-8-generic  N/A
>   linux-firmware                            1.52
>  SourcePackage: linux
>  UpgradeStatus: No upgrade log present (probably fresh install)
>  dmi.bios.date: 03/04/2011
>  dmi.bios.vendor: Dell Inc.
>  dmi.bios.version: X27
>  dmi.board.vendor: Dell Inc.
>  dmi.chassis.type: 9
>  dmi.chassis.vendor: Dell Inc.
>  dmi.modalias: dmi:bvnDellInc.:bvrX27:bd03/04/2011:svnDellInc.:pnPrecisionM6600:pvr01:rvnDellInc.:rn:rvr:cvnDellInc.:ct9:cvr:
>  dmi.product.name: Precision M6600
>  dmi.product.version: 01
>  dmi.sys.vendor: Dell Inc.
>
> To manage notifications about this bug go to:
> https://bugs.launchpad...

Read more...

Ara Pulido (ara) wrote :

Waiting on Marc's testing

Changed in linux (Ubuntu Natty):
status: Confirmed → Incomplete
Ara Pulido (ara) on 2011-08-16
tags: added: oneiric
Chris Van Hoof (vanhoof) wrote :

Kent -- If you have one of these machines handy it would be great to know what results you have after testing the kernel Ming built in Comment #9

Changed in linux (Ubuntu Natty):
assignee: Ming Lei (tom-leiming) → Marc Legris (maaarc)

Tested with Ming's kernel package, system (M4600) can now use firewire and sd cards normally.

Changed in linux (Ubuntu Natty):
status: Incomplete → Fix Committed
assignee: Marc Legris (maaarc) → Chris Van Hoof (vanhoof)
Kent Baxley (kentb) wrote :

@Chris, @Ming:

Tested kernel from comment #9 on a Latitude E5520m. Firewire and SD card are both working now.

Chris Van Hoof (vanhoof) wrote :

Thanks Marc & Kent

Changed in linux (Ubuntu Natty):
status: Fix Committed → Confirmed
assignee: Chris Van Hoof (vanhoof) → Ming Lei (tom-leiming)
Stefan Richter (stefan-r-ubz) wrote :

While we are at adding a quirk table entry for this controller --- could you please test whether another common controller bug is present in this device?

For the test, you need to have gcc installed, download this test tool:
http://user.in-berlin.de/~s5r6/linux1394/utils/test_cycle_time_v20100125.c
compile it with "gcc test_cycle_time_v20100125.c", and run it with "sudo ./a.out /dev/fw0".

The program then runs (possibly silently) for 60 seconds and then prints a test summary. Please post this output here.

The controller bug which is being tested for concerns timestamps which are used in industrial video applications and for audio I/O over FireWire. You can run this test without any devices attached to the FireWire controller, or with arbitrary devices attached to it (storage, video, audio --- doesn't matter for the test; and if you have a FireWire disk attached, you can even leave it mounted during the test).

Even if you don't have any of those devices yourself for which this potential other controller bug would be relevant, it would be nice if you could run the test and report the result. It could be of help to other fellow Linux users who may have such a device combination.

E5420m:
--------------------------------------------------------

grep: /usr/share/misc/oui.db: No such file or directory
394FC0 (unknown Vendor OUI)

0 cycleOffset backwards out of 14405531 samples (0.00e+00)
0 cycleCount backwards (0.00e+00)
0 cycleSeconds backwards (0.00e+00)

Stefan Richter (stefan-r-ubz) wrote :

Marc,
thank you very much. Evidently this controller has a correctly working Cycle Timer register.

Chris Van Hoof (vanhoof) on 2011-09-12
tags: added: blocks-hwcert-enablement
Tim Gardner (timg-tpi) on 2011-09-13
Changed in linux (Ubuntu Natty):
status: Confirmed → Fix Committed
Changed in linux (Ubuntu Oneiric):
status: Confirmed → Fix Committed
Launchpad Janitor (janitor) wrote :

This bug was fixed in the package linux - 3.0.0-11.18

---------------
linux (3.0.0-11.18) oneiric; urgency=low

  [ Jiri Kosina ]

  * SAUCE: HID: magicmouse: ignore 'ivalid report id' while switching modes

  [ Leann Ogasawara ]

  * SAUCE: x86: reboot: Make Dell Optiplex 790 use reboot=pci
    - LP: #818933
  * SAUCE: (drop after 3.0) x86, x2apic: enable the bios request for x2apic
    optout
    - LP: #797548

  [ Ming Lei ]

  * SAUCE: fireware: add NO_MSI quirks for o2micro controller
    - LP: #801719

  [ Rene Bolldorf ]

  * SAUCE: (drop after 3.0) ideapad: Check if acpi already handle backlight
    power in 'ideapad_backlight_notify_power' to avoid a page fault

  [ Upstream Kernel Changes ]

  * savagedb: Fix typo causing regression in savage4 series video chip
    detection
  * cifs: fix possible memory corruption in CIFSFindNext, CVE-2011-3191
    - LP: #834135
    - CVE-2011-3191
 -- Leann Ogasawara <email address hidden> Mon, 12 Sep 2011 06:45:02 -0700

Changed in linux (Ubuntu Oneiric):
status: Fix Committed → Fix Released

Also seeing this issue on the Latitude XT3 before/after updating system to -updates

Ming Lei (tom-leiming) wrote :

Hi Marc,

On Thu, Sep 29, 2011 at 2:55 AM, Marc Legris <email address hidden> wrote:
> Also seeing this issue on the Latitude XT3 before/after updating system
> to -updates

Please check to see if XT3 uses the same o2micro controller with this one.
If not, could you please file a new bug on it?

thanks,
--
Ming Lei

looks like it is slightly different, I'll log another bug

Herton R. Krzesinski (herton) wrote :

This bug is awaiting verification that the kernel for natty in -proposed solves the problem. Please test the kernel and update this bug with the results. If the problem is solved, change the tag 'verification-needed-natty' to 'verification-done-natty'.

If verification is not done by one week from today, this fix will be dropped from the source code, and this bug will be closed.

See https://wiki.ubuntu.com/Testing/EnableProposed for documentation how to enable and use -proposed. Thank you!

tags: added: verification-needed-natty

Tested the 2.6.38-11-generic.51 natty kernel with the Latitude E5520m, Precision M6600, and Precision M4600. SD and firewire devices now function correctly.

tags: added: verification-done-natty
removed: verification-needed-natty
Launchpad Janitor (janitor) wrote :
Download full text (10.3 KiB)

This bug was fixed in the package linux - 3.1.0-1.1

---------------
linux (3.1.0-1.1) precise; urgency=low

  [ Andiry Xu ]

  * SAUCE: (drop during 3.2 merge) xHCI: AMD isoc link TRB chain bit quirk
    - LP: #872811

  [ Andy Whitcroft ]

  * Revert "ubuntu: compcache -- follow changes to bd_claim/bd_release"
    - LP: #832694
  * Revert "ubuntu: compcache -- version 0.5.3"
    - LP: #832694
  * [Config] standardise CONFIG_NETFILTER_XT_TARGET_TCPOPTSTRIP=m
  * [Config] Enable CONFIG_MACVTAP=m
    - LP: #822601
  * record the compiler in the ABI and check for inconsistant builds
  * [Config] move ECRYPT_FS back to =y for all architectures
    - LP: #827197
  * [Config] enable CONFIG_DRM_VMWGFX=m
    - LP: #698009
  * [Config] re-fix ECRYPT_FS=y
    - LP: #827197
  * enforcer -- ensure we have CONFIG_ECRYPT_FS=y
    - LP: #827197
  * [Config] dropping compcache configuration options
  * [Config] standardise on HZ=250
  * SAUCE: headers_install: fix #include "..." usage for userspace
    - LP: #824377
  * make module-inclusion selection retain the left overs
  * add a new linux-image-extras package for virtual

  [ Colin Watson ]

  * Deliver more Atheros, Ralink, and iwlagn NIC drivers to d-i

  [ edwin_rong ]

  * SAUCE: Staging: add driver for Realtek RTS5139 cardreader
    - LP: #824273

  [ Greg Kroah-Hartman ]

  * SAUCE: staging: rts5139: add vmalloc.h to some files to fix the build.
    - LP: #824273

  [ Jesse Sung ]

  * SAUCE: Unregister input device only if it is registered
    - LP: #839238

  [ Jiri Kosina ]

  * SAUCE: HID: add MacBookAir4, 2 to hid_have_special_driver[]

  [ Joshua V. Dillon ]

  * SAUCE: HID: add support for MacBookAir4,2 keyboard.

  [ Kees Cook ]

  * [Config] enable and enforce SECCOMP_FILTER on x86

  [ Keng-Yu Lin ]

  * [Config] Enable CONFIG_RTS5139=m on i386/amd64
    - LP: #824273

  [ Leann Ogasawara ]

  * Revert "ubuntu: overlayfs -- ovl: make lower mount read-only"
  * Revert "ubuntu: overlayfs -- fs: limit filesystem stacking depth"
  * Revert "ubuntu: overlayfs -- ovl: improve stack use of lookup and
    readdir"
  * Revert "ubuntu: overlayfs -- ovl: fix overlayfs over overlayfs"
  * Revert "ubuntu: overlayfs -- overlayfs: implement show_options"
  * Revert "ubuntu: overlayfs -- overlayfs: add statfs support"
  * Revert "ubuntu: overlayfs -- overlay filesystem"
  * Revert "ubuntu: overlayfs -- overlay: overlay filesystem documentation"
  * Revert "SAUCE: ARM: OMAP: Add macros for comparing silicon revision"
  * Revert "SAUCE: OMAP: DSS2: check for both cpu type and revision, rather
    than just revision"
  * Revert "SAUCE: OMAP: DSS2: enable hsclk in dsi_pll_init for OMAP36XX"
  * Revert "ubuntu: fsam7400 disable driver"
    - LP: #876030
  * rebase to v3.1-rc1
  * [Config] updateconfigs after rebase to v3.1-rc1
  * rebase to v3.1-rc2
  * [Config] Updateconfigs after rebase to v3.1-rc2
  * ubuntu: Yama - update calls to generic_permission() and
    inode->i_op->permission()
  * ubuntu: ndiswrapper -- remove netdev_priv macro
  * ubuntu: aufs -- Temporarily disable due to build failure
  * [Config] Diable INTEL_MID_PTI on armel
  * [Config] Temporarily disable CONFIG_FTMAC100 on armel
  * [Conf...

Changed in linux (Ubuntu Precise):
status: Fix Committed → Fix Released
Jim Moore (moore4him) on 2011-10-24
Changed in linux (Ubuntu Natty):
status: Fix Committed → Fix Released
To post a comment you must log in.